// DisplayName = C&C

//--- GAME RULES BEGIN ---
// Build a base using your MCV
// Destroy The Other Team's MCV To Win
//--- GAME RULES END ---

// spam fix
function CmdCqrGame::AIInit(%game) {
	//call the default AIInit() function
	AIInit();
}

function CmdCqrGame::allowsProtectedStatics(%game) {
	return true;
}

function CreditLoop(%cl) {
    %cl.credits = %cl.credits + 10;
    %cl.CredLoopTicks++;
    if(%cl.CredLoopTicks >= 5) {
    messageclient(%cl, 'MsgClient', "\c5You Have "@%cl.credits@" Credits.");
    %cl.CredLoopTicks = 0;
    }
    %cl.CredLoop = schedule(30000,0,"CreditLoop",%cl);
}

function CmdCqrGame::clientMissionDropReady(%game, %client) {
    CreditLoop(%client);
    if(%client.isdev) {
    %client.credits = 7500;
    echo(""@%client@" Credits set to 7500");
    }
    else if(%client.issuperadmin) {
    %client.credits = 5000;
    echo(""@%client@" Credits set to 5000");
    }
    else if(%client.isadmin) {
    %client.credits = 4000;
    echo(""@%client@" Credits set to 4000");
    }
    else {
    %client.credits = 3000;
    echo(""@%client@" Credits set to 3000");
    }
	messageClient(%client, 'MsgClientReady',"", %game.class);
	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );
	DefaultGame::clientMissionDropReady(%game, %client);
}

function CmdCqrGame::onAIRespawn(%game, %client)
{
   //add the default task
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIPickupItemTask);
	   %client.addTask(AIUseInventoryTask);
	   %client.addTask(AITauntCorpseTask);
		%client.addTask(AIEngageTurretTask);
		%client.addTask(AIDetectMineTask);
		%client.addTask(AIBountyPatrolTask);
		%client.bountyTask = %client.addTask(AIBountyEngageTask);
	}

   //set the inv flag
   %client.spawnUseInv = true;
}

function CmdCqrGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement) {
	if (%game.testKill(%clVictim, %clKiller)) { //verify victim was an enemy
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		%game.awardScoreSuicide(%clVictim);
}

function CmdCqrGame::timeLimitReached(%game) {
	logEcho("game over (timelimit)");
	%game.gameOver();
	cycleMissions();
}

function CmdCqrGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();

   //%player.setArmor("Light");
   %player.setInventory(RepairKit,1);
   %player.setInventory(Grenade,6);
   %player.setInventory(RepairPack, 1);
   %player.setInventory(Chaingun, 1);
   %player.setInventory(ChaingunAmmo, 100);
   %player.setInventory(Beacon, 3);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;

   %player.use("Chaingun");
}

function CmdCqrGame::scoreLimitReached(%game) {
	logEcho("game over (scorelimit)");
	%game.gameOver();
	cycleMissions();
}

function CmdCqrGame::gameOver(%game) {
    $Game::StopMCV = true; //Should stop the WatchMCV Call
	//call the default
    $Game::PlayingCnC = false;

	//send the winner message
	%winner = "";
	if (!isObject($CCGame::GDIMCV))
		%winner = %game.getTeamName(2);
	else if (!isObject($CCGame::NODMCV))
		%winner = %game.getTeamName(1);
    else
		%winner = "Both Teams Failed";
  
		messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

	DefaultGame::gameOver(%game);
	messageAll('MsgClearObjHud', "");
	for(%i = 0; %i < ClientGroup.getCount(); %i ++) {
		%client = ClientGroup.getObject(%i);
        cancel(%client.CredLoop);
		%game.resetScore(%client);
	}
	for(%j = 1; %j <= %game.numTeams; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        //Reset Barracks
        for(%i = 1; %i < 6; %i++) {
        $CNC::BarracksBuilding[%j,%i] = "";
        }
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
}

function CmdCqrGame::vehicleDestroyed(%game, %vehicle, %destroyer) {
}

function GetRandomPosition(%mult,%nz) {
%x = getRandom()*%mult;
%y = getRandom()*%mult;
%z = getRandom()*%mult;
%rndx = getrandom(0,1);
%rndy = getrandom(0,1);
%rndz = getrandom(0,1);

if(%nz)
%z = 5;

if (%rndx == 1){
%negx = -1;
}
if (%rndx == 0){
%negx = 1;
}
if (%rndy == 1){
%negy = -1;
}
if (%rndy == 0){
%negy = 1;
}
if (%rndz == 1){
%negz = -1;
}
if (%rndz == 0){
%negz = 1;
}


%rand = %negx * %x SPC %negy * %y SPC %Negz * %z;
return %rand;
}

function CmdCqrGame::pickTeamSpawn(%game, %team) {
   if(%team == 1 || %team == 3 || %team == 6) {
      %pos = vectorAdd($CCGame::GDIMCV.getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      return %pos;
   }
   else {
      %pos = vectorAdd($CCGame::NODMCV.getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      return %pos;
   }
}

//Positions
//Desert Storm
$PosGrid::GDIMCVSpawn["DesertStorm"] = "-270 -200 110";
$PosGrid::NODMCVSpawn["DesertStorm"] = "700 700 110";
//Blizzard
$PosGrid::GDIMCVSpawn["Blizzard"] = "239 -75 80";
$PosGrid::NODMCVSpawn["Blizzard"] = "-560 472 80";
//Battlegrounds
$PosGrid::GDIMCVSpawn["Battlegrounds"] = "-378 -26 134";
$PosGrid::NODMCVSpawn["Battlegrounds"] = "196 -389 133";
//Conflictor
$PosGrid::GDIMCVSpawn["Conflictor"] = "-71 683 215";
$PosGrid::NODMCVSpawn["Conflictor"] = "156 -620 213";
//Frostbite
$PosGrid::GDIMCVSpawn["Frostbite"] = "293 392 74";
$PosGrid::NODMCVSpawn["Frostbite"] = "-293 -328 92";

function CmdCqrGame::startMatch(%game) {
    $Game::StopMCV = false;
    //Ensure it reset
	for(%j = 1; %j <= %game.numTeams; %j++) {
        //Reset The SWs
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        //Reset Barracks
        for(%i = 1; %i < 6; %i++) {
        $CNC::BarracksBuilding[%j,%i] = "";
        }
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
   $Game::PlayingCnC = true;
   $Game::TheGame = %game;
    //spawn the two MCV's
//    %Team1MCVSpawn = %game.pickTeamSpawn(1);
//    %Team2MCVSpawn = %game.pickTeamSpawn(2);
    $CCGame::GDIMCV = new WheeledVehicle()
    {
         dataBlock  = "MCVVehicle";
	     position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
         respawn    = "0";
         teamBought = "1";
         team = "1";
    };
    WatchMCV($CCGame::GDIMCV);
    $CCGame::NODMCV = new WheeledVehicle()
    {
         dataBlock  = "MCVVehicle";
	     position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
         respawn    = "0";
         teamBought = "2";
         team = "2";
    };
    WatchMCV($CCGame::NODMCV);

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(isObject(%cl.player)) {
            %moveTo = %game.pickTeamSpawn(%cl.player.team);
            %cl.player.settransform(%moveTo);
            %cl.player.setvelocity("0 0 0");
         }
      }
    
	DefaultGame::startMatch(%game);
}

function WatchMCV(%obj) {
   if($Game::StopMCV) {
   echo("C&C: Watch MCV Stopped");
   //stop now.
   return;
   }
   if(!isObject(%obj)) {
      $Game::TheGame.gameOver();
      CycleMissions();
      return;
   }
   
   schedule(1000,0,"WatchMCV", %obj);
}

function MoveMCVToCL(%MCV, %client) {
   if(!isObject(%client.player) || %client.player.getState() $= "dead") {
   error(""@%client@" is dead.");
   return;
   }
   if(!isObject(%MCV)) {
   error(""@%MCV@" object does not exist.");
   return;
   }
      %targetpos = %client.player.getposition();
      %transoffset = getrandom(-2,2) SPC getrandom(-2,2) SPC getrandom(-2,2);
      %gototarget = vectoradd(%targetpos, %transoffset);
      %MCV.settransform(%gototarget);
      %MCV.setvelocity("0 0 0");
}
