//--------------------------------------------------------------------------
// Deployable Generator
//--------------------------------------------------------------------------

//ION CANNON
datablock EffectProfile(IonCannonBoomEffect)
{
   effectname = "Weapons/IonCannon_Explosion";
   minDistance = 5.0;
   maxDistance = 250.0;
};

datablock AudioProfile(IonCannonExplosionSound)
{
   filename    = "fx/vehicles/bomber_bomb_reload.wav";
   description = AudioBIGExplosion3d;
   preload = true;
   effect = IonCannonBoomEffect;
};

datablock ParticleData(IonCannonParticle) {
	dragCoeffiecient     = 0.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;

	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 0;

	textureName          = "particleTest";

	useInvAlpha = false;
	spinRandomMin = -160.0;
	spinRandomMax = 160.0;

    textureName  = "flarebase";

	colors[0]     = "0 0 1";
	colors[1]     = "0 0 1";
	colors[2]     = "0 0 1";
	colors[3]     = "0 0 1";
	sizes[0]      = 10;
	sizes[1]      = 20;
	sizes[2]      = 30;
    sizes[3]      = 30;
	times[0]      = 0.0;
	times[1]      = 0.01;
	times[2]      = 0.02;
    times[3]      = 1;
};

datablock ParticleEmitterData(IonCannonEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   spinRandomMin   = "200";
   spinRandomMax   = "-200";
   overrideAdvances = false;
   particles = "IonCannonParticle";
};

datablock LinearFlareProjectileData(IonCannonLaser)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "0.5 0.5 0.5";
   faceViewer          = true;
   directDamage        = 5.9; //die.
   hasDamageRadius     = true;
   indirectDamage      = 5.9;
   damageRadius        = 25;
   kickBackStrength    = 150.0;
   radiusDamageType    = $DamageType::Plasma; //Cause Ze Burn

   explosion           = "IonCannonExplosion";
   splash              = "";
   baseEmitter         = IonCannonEmitter;
   dryVelocity       = 1000.0;
   wetVelocity       = 1000.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 17000;
   lifetimeMS        = 17000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 0;

   activateDelayMS = -1;

   size[0]           = 0.01;
   size[1]           = 0.01;
   size[2]           = 0.01;

   numFlares         = 1;
   flareColor        = "0 0 1";
   flareModTexture   = "special/stationglow";//"special/sniper00";//"special/stationglow";//"flaremod";
   flareBaseTexture  = "special/lightFalloffMono";//"flarebase";

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 0 1";

};

datablock ShockwaveData(IonCannonExplosionShockwave)
{
   width = 6.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 1;
   acceleration = 400;
   lifetimeMS = 1500;
   height = 10.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.4 1.0 0.4 0.50";
   colors[1] = "0.4 1.0 0.4 0.25";
   colors[2] = "0.4 1.0 0.4 0.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(IonCannonExplosion)
{
   soundProfile   = IonCannonExplosionSound;

   shockwave = IonCannonExplosionShockwave;
   shockwaveOnTerrain = false;

   explosionShape = "effect_plasma_explosion.dts";
   faceViewer     = true;
   delayMS = 160;

   offset = 0;

   playSpeed = 0.45;

   sizes  = "40 60 40";

   shakeCamera = true;
   camShakeFreq = "2 2 0";
   camShakeAmp = "20.0 20.0 0.0";
   camShakeDuration = 1.0;
   camShakeRadius = 1000.0;

};


///////////////////
//BUILDING
datablock SensorData(IonControlSensorObj)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = true;
   detectsCloaked = true;
   detectionPings = true;
   detectRadius = 2000;
};


datablock StaticShapeData(DeployedIonControl) : StaticShapeDamageProfile {
   className = Sensor;
   catagory = "Sensors";
   shapeFile = "stackable3m.dts";
   maxDamage = 4.0;
   destroyedLevel = 4.0;
   disabledLevel = 3.85;
   explosion      = ShapeExplosion;
   expDmgRadius = 10.0;
   expDamage = 0.5;
   expImpulse = 2000.0;

   dynamicType = $TypeMasks::StaticShapeObjectType;
   isShielded = true;
   energyPerDamagePoint = 33;
   maxEnergy = 110;
   rechargeRate = 0.31;
   ambientThreadPowered = true;
   humSound = SensorHumSound;

   cmdCategory = "Support";
   cmdIcon = CMDSensorIcon;
   cmdMiniIconName = "commander/MiniIcons/com_sensor_grey";
   targetNameTag = 'Ion Cannon Control';
   targetTypeTag = '';
   sensorData = IonControlSensorObj;
   sensorRadius = IonControlSensorObj.detectRadius;
   sensorColor = "255 194 9";

   debrisShapeName = "debris_generic.dts";
   debris = StaticShapeDebris;
};


datablock ShapeBaseImageData(IonControlImage) {
	mass = 20;
	emap = true;
	shapeFile = "stackable1s.dts";
	item = IonControlDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = DeployedIonControl;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = true;
	maxDepSlope = 360;
	deploySound = ItemPickupSound;

	minDeployDis = 2;
	maxDeployDis = 5;
};

datablock ItemData(IonControlDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "stackable1s.dts";
	mass = 5.0;

	hasLight = true;
	lightType = "PulsingLight";
	lightColor = "0.1 0.8 0.8 1.0";
	lightTime = "1000";
	lightRadius = "3";

	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 3;
	rotate = true;
	image = "IonControlImage";
	pickUpName = "a Power Plant";
	heatSignature = 0;
	emap = true;
};

function IonControlImage::testNoTerrainFound(%item) {
	// don't check this for non-Landspike turret deployables
}

function IonControlDeployable::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function IonControlImage::onDeploy(%item, %plyr, %slot) {

    if($BuildingCount::PowerPlant[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
    return;
    }
    if($BuildingCount::CommCenter[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
    return;
    }
    if($CNC::IonControl[%plyr.client.team] !$= "") {
    messageclient(%plyr.client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
    return;
    }

	%className = "StaticShape";

	%playerVector = vectorNormalize(getWord(%plyr.getEyeVector(),1) SPC -1 * getWord(%plyr.getEyeVector(),0) SPC "0");

	if (vAbs(floorVec(%item.surfaceNrm,100)) $= "0 0 1")
		%item.surfaceNrm2 = vectorScale(%playerVector,-1);
	else
		%item.surfaceNrm2 = vectorNormalize(vectorCross(%item.surfaceNrm,"0 0 1"));

	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);

	%item.surfacePt = vectorAdd(%item.surfacePt,vectorScale(vectorNormalize(vectorCross(%item.surfaceNrm,%item.surfaceNrm2)),2));

	%deplObj = new (%className)() {
		dataBlock = DeployedIonControl;
        scale = "10 10 10";
		deployed = true;
	};

	// set orientation
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// set team, owner, and handle
	%deplObj.team = %plyr.client.Team;

	// set power frequency
	%deplObj.powerFreq = %plyr.powerFreq;

	// set power
	%deplObj.setSelfPowered();

	// set the sensor group if it needs one
	if (%deplObj.getTarget() != -1)
		setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());

	// increment the team count for this deployed object
	$TeamDeployedCount[%plyr.team, %item.item]++;

	addDSurface(%item.surface,%deplObj);

	%deplObj.playThread($PowerThread,"Power");

    $BuildingCount::IonControl[%deplObj.team]++;
    $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
    %deplObj.team.IonControlCount++;

	// take the deployable off the player's back and out of inventory
	%plyr.unmountImage(%slot);
	%plyr.decInventory(%item.item, 1);

	// add to power list
	$PowerList = listAdd($PowerList,%deplObj,-1);

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Ion Cannon Control.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Ion Cannon Charging.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Ion Cannon Control Detected.");
         }
      }
    $CNC::IonControl[%deplObj.team] = %deplObj;   //one per team
    %deplObj.canFireIonCannon = 0;
    %deplObj.IonCannonSched = schedule(240000,0,"IonCannonReady",%deplObj);

	return %deplObj;
}

function DeployedIonControl::onDestroyed(%this,%obj,%prevState) {

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %obj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost, Ion Cannon Control.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Ion Cannon Disabled.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Ion Cannon Control Destroyed.");
         }
      }

   cancel(%obj.IonCannonSched);
   $CNC::IonControl[%obj.team] = "";
   $BuildingCount::IonControl[%obj.team]--;
   $TeamDeployedCount[%obj.team,IonControlDeployable]--;
   $Power[%obj.team] = $Power[%obj.team] + 250; //Remove 250 Power From The Team Count
   %obj.team.IonControlCount--;
   remDSurface(%obj);
   %obj.schedule(500,"delete");
   Parent::onDestroyed(%data,%obj,%prevState);
}

function IonControlImage::onMount(%data,%obj,%node) {
	%obj.hasGen = true; // set for gencheck
}

function IonControlImage::onUnmount(%data,%obj,%node) {
	%obj.hasGen = "";
}

//NUCLEAR MISSILE
function IonCannonReady(%obj) {
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Ion Cannon Ready.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: ENEMY Ion Cannon Ready.");
      }
   }
   %obj.canFireIonCannon = 1;
}

//Prep & Sound
datablock EffectProfile(IonCannonPrepEffect)
{
   effectname = "C&C/IonControl/IonCannonPrep";
   minDistance = 100;
   maxDistance = 250;
};

datablock AudioProfile(IonCannonPrepSound)
{
   filename    = "fx/vehicles/tank_activate.wav";
   description = AudioExplosion3d;
   effect = IonCannonPrepEffect;
};

function PrepIonCannon(%obj, %pos) {
   if(!isObject(%obj)) {
   return;
   }
   %obj.IonCannonSched = schedule(240000,0,"IonCannonReady",%obj);
   %obj.canFireIonCannon = 0;
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Ion Cannon Preping.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: Ion Cannon Targeted. ~wfx/misc/red_alert_short.wav");
      }
   }
   serverPlay3D(IonCannonPrepSound, %obj.position);
   schedule(12500,0,"IonCannonDrop",%obj, %pos);
}

function IonCannonDrop(%obj, %pos) {
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Ion Cannon Activated.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: Ion Cannon Fired. ~wfx/misc/red_alert.wav");
      }
   }
   %nooke = new (LinearFlareProjectile)() {
   dataBlock = IonCannonLaser;
   initialDirection = "0 0 -100";
   initialPosition = vectorAdd(%pos, "0 0 1000");
   sourceObject = %obj;
   damageFactor = 1;
   };
   MissionCleanup.Add(%nooke);
}
