datablock AudioProfile(ObeliskChargeSound)
{
   filename    = "fx/weapons/ELF_fire.wav";
   description = AudioClose3d;
   preload = true;
   effect = ObeliskEffects;
};

datablock AudioProfile(ObeliskFireSound)
{
   filename    = "fx/powered/turret_plasma_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = ObeliskEffects;
};

datablock EffectProfile(ObeliskEffects)
{
   effectname = "Weapons/Sounds_Obelisk";
   minDistance = 1;
   maxDistance = 600;
};

datablock ParticleData(ObeliskChargeParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 0.3;
   inheritedVelFactor   = 0.7;
   constantAcceleration = 4.8;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 550;
   textureName          = "special/crescent3";
   useInvAlpha          =  false;
   colors[0]     = "1 0.1 0.1 1.0";
   colors[1]     = "0.9 0.1 0.1 1.0";
   colors[2]     = "0.9 0.1 0.1";
   sizes[0]      = 1.001;
   sizes[1]      = 1.001;
   sizes[2]      = 1.001;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(ObeliskChargeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;

   ejectionVelocity = 3.7;  // A little oomph at the back end
   velocityVariance = 0.0;
   ejectionoffset = 2;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   phiReferenceVel = "0";
   phiVariance = "360";
   particles = "ObeliskChargeParticle";
};

datablock SniperProjectileData(ObeliskBeam)
{
   directDamage        = 10;
   hasDamageRadius     = true;
   indirectDamage      = 4.0;
   damageRadius        = 10.0;
   velInheritFactor    = 0.0;
   kickBackStrength    = 0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "BlasterExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Explosion;

   maxRifleRange       = 1000;
   rifleHeadMultiplier = 1.3;
   beamColor           = "1 0 0";
   fadeTime            = 1.5;

   startBeamWidth		  = 2.2;
   endBeamWidth 	     = 2.2;
   pulseBeamWidth 	  = 0.15;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 90.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "1 0 0";

   useInvAlpha =  false;
   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/shieldenvmap";
   textureName[3]      = "special/shieldenvmap";
   textureName[4]      = "special/shieldenvmap";
   textureName[5]      = "special/shieldenvmap";
   textureName[6]      = "special/shieldenvmap";
   textureName[7]      = "special/shieldenvmap";
   textureName[8]      = "special/shieldenvmap";
   textureName[9]      = "special/shieldenvmap";
   textureName[10]     = "special/shieldenvmap";
   textureName[11]     = "special/shieldenvmap";
};
//--------------------------------------------------------------------------
// Plasma Turret Image
//--------------------------------------------------------------------------

datablock TurretImageData(ObeliskBarrelLarge)
{
   shapeFile = "turret_fusion_large.dts";
   // ---------------------------------------------
   // z0dd - ZOD, 5/8/02. Incorrect parameter value
   //item      = PlasmaBarrelLargePack;
   item = ObeliskBarrelPack;

   projectile = ObeliskBeam;
   projectileType = SniperProjectile;
   usesEnergy = true;
   fireEnergy = 10;
   minEnergy = 10;
   emap = true;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 300;
   degPerSecPhi      = 500;
   attackRadius      = 350;

   // State transitions
   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateSound[1]                 = PBLSwitchSound;
   stateTimeoutValue[1]          = 1;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";
   stateTransitionOnNoAmmo[1]    = "NoAmmo";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnTriggerDown[2] = "Charge";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";
   
   stateName[3]                     = "Charge";
   stateSound[3]                    = ObeliskChargeSound;
   stateSpinThread[3] = FullSpeed;
   stateEmitter[3] = "ObeliskChargeEmitter";
   stateEmitterTime[3] = 2.0;
   stateEmitterNode[3] = "muzzlePoint1";
   stateTimeoutValue[3]             = 2.0;
   stateTransitionOnTimeout[3]  = "Fire";

   stateName[4]                = "Fire";
   stateTransitionOnTimeout[4] = "Reload";
   stateTimeoutValue[4]        = 0.3;
   stateFire[4]                = true;
   stateRecoil[4]              = LightRecoil;
   stateAllowImageChange[4]    = false;
   stateSequence[4]            = "Fire";
   stateSound[4]               = ObeliskFireSound;
   stateScript[4]              = "onFire";

   stateName[5]                  = "Reload";
   stateTimeoutValue[5]          = 1.8;
   stateAllowImageChange[5]      = false;
   stateSequence[5]              = "Reload";
   stateTransitionOnTimeout[5]   = "Ready";
   stateTransitionOnNotLoaded[5] = "Deactivate";
   stateTransitionOnNoAmmo[5]    = "NoAmmo";

   stateName[6]                = "Deactivate";
   stateSequence[6]            = "Activate";
   stateDirection[6]           = false;
   stateTimeoutValue[6]        = 1;
   stateTransitionOnLoaded[6]  = "ActivateReady";
   stateTransitionOnTimeout[6] = "Dead";

   stateName[7]               = "Dead";
   stateTransitionOnLoaded[7] = "ActivateReady";

   stateName[8]             = "NoAmmo";
   stateTransitionOnAmmo[8] = "Reload";
   stateSequence[8]         = "NoAmmo";
};

function ObeliskBarrelLarge::OnFire(%data, %obj, %slot) {     //Needs This.
%p = new (SniperProjectile)() {
dataBlock = ObeliskBeam;
initialDirection = %obj.getMuzzleVector(%slot);
initialPosition = %obj.getMuzzlePoint(%slot);
sourceObject = %obj;
damageFactor = 1;
sourceSlot = %slot;
};
%p.setEnergyPercentage(100);
MissionCleanup.Add(%p);
}

function ObeliskBeam::onCollision(%data,%projectile,%targetObject,%modifier,%position,%normal) {
if (%targetObject.getClassName() $= "Player") {
%DM = getRandom(1,5);
switch(%DM) {
case 1: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@" enjoys attenton from a NOD Obelisk.");
case 2: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@", when a big red ball appears over a tower.. Run..");
case 3: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@" Sucks Big Hot Red Laser from an obelisk.");
case 4: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@" Watches a red ball of fury appear over the obelisk, sadly, he doesn't move.");
case 5: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@" Burns to death from laser fury.");
default: messageall('msgobeliskowned', "\c0"@%targetobject.client.namebase@" Sees the obelisk pwn him with a laser.");
}
%TargetObject.ScriptKill(0);
}
else {
   %TargetObject.damage(0, %TargetObject.position, 1.2, $DamageType::Explosion);
}
//else {
//%targetObject.setDamageState("Destroyed");
//}
}
